import { App } from 'vue'

export function formatDate(value: string) {
  return value.split(' ')[0].replace(/-/g, '/')
}

const filters = { formatDate }

export default {
  install(app: App) {
    app.config.globalProperties.$filters = filters
  },
}

declare module '@vue/runtime-core' {
  interface ComponentCustomProperties {
    $filters: typeof filters
  }
}
