import request from './request'

export function register(data: ApiUser.Register.Request) {
  return request.post('/user/register', data)
}

export function login(data: ApiUser.Login.Request) {
  return request.post('/user/login', data)
}

export function logout() {
  return request.post('/user/logout')
}

export function sendPasswordEmail(email: string) {
  return request.post('/user/password/email', { email })
}

export function resetPassword(data: ApiUser.PasswordReset.Request) {
  return request.post('/user/password/reset', data)
}

export function changePassword(data: ApiUser.PasswordChange.Request) {
  return request.post('/user/password/change', data)
}

export function updateUserInfo(data: ApiUser.Update.Request) {
  return request.post('/user/update', data)
}

export function getUserInfo(reportError?: boolean) {
  return request.get<ApiUser.Info.Response>('/user/info', {
    reportError,
    headers: {
      'Cache-Control': 'no-cache',
    },
  })
}

export function inviteFriends(emails: string) {
  return request.post('/user/invite', { emails })
}

export function getInviteRewards() {
  return request.get('/user/invite/rewards')
}

export function getInviteCoupon() {
  return request.get('/invite/coupon')
}
